﻿Public Class Form1
    ' Start the long process.
    Private Sub btnStartProcess_Click() Handles btnStartProcess.Click
        ' Get ready.
        btnStartProcess.Enabled = False
        btnCancel.Enabled = True
        prgLongProcess.Value = 0

        ' Start the worker.
        bgrLongProcess.WorkerReportsProgress = True
        bgrLongProcess.WorkerSupportsCancellation = True
        bgrLongProcess.RunWorkerAsync()
    End Sub

    ' Cancel the long process.
    Private Sub btnCancel_Click() Handles btnCancel.Click
        bgrLongProcess.CancelAsync()
    End Sub

    ' Display the progress.
    Private Sub bgrLongProcess_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles bgrLongProcess.ProgressChanged
        prgLongProcess.Value = e.ProgressPercentage
    End Sub

    ' The worker is done.
    Private Sub bgrLongProcess_RunWorkerCompleted() Handles bgrLongProcess.RunWorkerCompleted
        btnStartProcess.Enabled = True
        btnCancel.Enabled = False
        prgLongProcess.Value = 0
    End Sub

    ' Do the work.
    Private Sub bgrLongProcess_DoWork() Handles bgrLongProcess.DoWork
        ' This example just wastes some time.
        Const NUM_SECONDS As Integer = 5
        For i As Integer = 1 To NUM_SECONDS
            ' Pause 1 second.
            Dim wait_until As Date = Now.AddSeconds(1)
            Do While Now < wait_until

            Loop

            ' If the user has canceled, stop.
            If bgrLongProcess.CancellationPending Then Exit Sub

            ' Report our progress.
            bgrLongProcess.ReportProgress(CInt(100 * i / NUM_SECONDS))
        Next i
    End Sub
End Class
